-- MouseClick.lua

-- Variables setting  ---------------------------------------------------
addSearchResourcesPath ( moduleDirectory .. "/configuration/" )
local Mouse_On = sasl.gl.loadImage ( "H6K_mouse_icon_On.png" , 0, 0, 160, 100 )
local Mouse_Off= sasl.gl.loadImage ( "H6K_mouse_icon_Off.png", 0, 0, 160, 100 )
eyeZ = { -8.08, -5.05, -4.55, 3.26, 8.92, 15.77 }
eyeY = {  0.21, -0.37,  0.38, 0.28, 0.76,  1.68 }

function draw()
	if get(isExternal) == 0 then
		if get(WalkerIsOn) == 1 then
			sasl.gl.drawTexture( Mouse_On , 0, 0, 110, 80)
		else
			sasl.gl.drawTexture( Mouse_Off, 0, 0, 110, 80)
		end
	end
end

function getHeadY()
	for n = 1, 6 do
		if get(HeadZ) == eyeZ[n] then
			eyeLevel = eyeY[n]
			return eyeLevel
		end
	end
	
	for n = 1, 5 do
		if eyeZ[n] < get(HeadZ) then
			yStart = eyeY[n]
			yEnd = eyeY[n+1]
			zStart = eyeZ[n]
			zEnd = eyeZ[n+1]
		end
	end
	eyeLevel = yStart + (yEnd-yStart)*(get(HeadZ)-zStart)/(zEnd-zStart)
	return eyeLevel
end

function onMouseWheel( component, x, y, button, parentX, parentY, value )
	if get(isExternal)==0 and get(WalkerIsOn)==1 then
		print("value=", value, get(CurrHead) ,get(WalkerIsOn), get(isExternal))
		if value ~= 0 then
			if get(CurrHead) == 0 then
				set(HeadZ, get(HeadZ) - 0.2*value )
			else
				set(HeadZ, get(HeadZ) + 0.2*value )
			end
		end
			
		if get(HeadZ) < eyeZ[1] then
			set(HeadZ, eyeZ[1])
		end
		
		if get(HeadZ) > eyeZ[6] then
			set(HeadZ, eyeZ[6])
		end
		
		val = getHeadY()
		set(HeadY, val)
		iniHeadY = get(HeadY)
		iniHeadZ = get(HeadZ)
	end
	return true
end

function onMouseDown ( component, x, y, button, parentX, parentY )
	if get(WalkerIsOn) == 1 then
		if button == MB_LEFT then
			set(TurnLeft, 1 - get(TurnLeft))
		end

		if button == MB_RIGHT then
			set(TurnRight, 1 - get(TurnRight))
		end
		return true
	end
end